
function y = CalculateMultMatrix2(naturalAbundances, atomCount, sumOfLabels, resVect, origAtomCount)


%end of recursion

if sumOfLabels == 0
     %fill the vector with +0 isotopes
      resVect(1) = origAtomCount - sum(resVect);
      y = resVect;
      return
   % compose all combinations of isotopes to reach the required mass   
  else
      maxLabel = length(naturalAbundances) - 1;
    
      %if maxLabel > sumOfLabels % forget too heavy isotopomers
      %  maxLabel = sumOfLabels;  
      %end
   
      if atomCount * maxLabel < sumOfLabels
        y = zeros(0,length(resVect));
        return
      end
        
      
      maxTimes = floor(sumOfLabels / maxLabel); % how many times the heaviest isotope can be taken from sumOfLabels
      naturalAbundances(length(naturalAbundances)) = []; %delete the heaviest isotope from the list
      resMat = zeros(0,length(resVect));
      for i = 0 : maxTimes
          t = maxLabel+1;
          resVect(t) = i;
          resMat = vertcat(resMat,CalculateMultMatrix2(naturalAbundances, atomCount-i, sumOfLabels - (i*maxLabel), resVect, origAtomCount));
      end
      
  end
          
  y = resMat;
      