%recursive function that creates matrix that enumerates all the possible combinations to get certain amount of extra neutrons
%atomFormula= the amount of different kind of non labeled atoms in molecule
%freeLabels = number of required labels
%combCand = vector that represents combination that is currently constructed
%currentAtom = number currently inspected atom in atomFormula-vector
%combMatrix = resultMatrix
function y = CreateAtomCombMatrix(atomFormula, freeLabels, combCand, currentAtom, combMatrix)

  
   numOfTypes = length (atomFormula);
   %combMatrix = zeros(0,numOfTypes);

   if currentAtom == numOfTypes %is current atom type the last one? End of recursion
       if atomFormula(numOfTypes) >= freeLabels %correct amount of labes can be reached
           combCand(numOfTypes) = freeLabels;
           combMatrix = cat(1, combMatrix, combCand);
       end
   else 
   
     j = freeLabels;
   
       
   if freeLabels > atomFormula(currentAtom)
       j= atomFormula(currentAtom);
   end     
       
   for i = j: -1 : 0
       combCand(currentAtom) = i;
       combMatrix = CreateAtomCombMatrix(atomFormula, freeLabels - i, combCand, currentAtom +1, combMatrix);
   end
   end
   
   y = combMatrix;

  

  

  