%function calculates base mass of given compound
%formula = atom types in the compound
%atomCounts = number atoms of every atom type
function y = CalculateBaseMass(formula, atomCounts)
        
    sum = 0;
    for i = 1 : length(formula)
        temp = isElement(formula{i});
        if temp ~= 0
            sum = sum + (atomCounts(i)*temp);
        else
            myError('Unknown Atomtype!','Error in CalculateBaseMass');
        end
    end
    
    y = sum;