%function creates matrix that enumerates all the combinations of possible positional isotopomers
%numOfPos 0 number of positions where extra neutron can be (eg. length of carbon chain)
function y = CreateCombMatrix(numOfPos)

   
    combMatrix = zeros(numOfPos,2 ^ numOfPos);
    sign = 0;
    c = 0;
    for i = 1: numOfPos
        for k = 1: 2 ^ i ; 
            for j = 1: (2 ^ numOfPos) / 2 ^ i
                combMatrix(i,j + c * (2 ^ numOfPos / 2 ^ i)) = sign;
                
            end
            c = c + 1 ;         
            if sign == 0;
                sign = 1;
            else sign = 0;
            end
        end
        c = 0;
    end
    
    y = combMatrix;

