%helper function that returns fregment that was left out from the original molecule during fragmentation (original molecule \ fragment = moduloFramgent)
%fragNum = the number of the fragment in fragments-structure 
function y = CreateModuloFragment(fragNum)

    global fragments;
    global labelType;
    
    moduloFragment.peak = fragments{fragNum}.peak;
    %moduloFragment.carbons =  ~fragments{fragNum}.carbons;
    moduloFragment.formula = fragments{1}.formula;
    moduloFragment.atomCount = fragments{1}.atomCount;
    
    for i = 1 : length(fragments{fragNum}.formula)
        for j = 1 : length(fragments{1}.formula)
            if fragments{fragNum}.formula{i} == fragments{1}.formula{j}
                moduloFragment.atomCount(j) = fragments{1}.atomCount(j) - fragments{fragNum}.atomCount(i);
                break;
            end
        end
    end
    
     for j = 1:length(moduloFragment.formula)
            if moduloFragment.formula{j} == labelType
                indexOfLabel = j;
                break;
            end
    end
    
    %remove labeled atom
    moduloFragment.atomCount(indexOfLabel) = [];
    moduloFragment.formula(indexOfLabel) = [];
    y = moduloFragment;
    