%function that calculates (incomplete) positional isotopomer distribution from underdetermined linear equation system
%multMat = coefficient matrix
%intenVect = vector that contains concatenated mass isotopomer distributions of labelled part of the product and it's framgents
function y = FindDepedencies(multMat,intenVect)
%
global epsilon

intenVect = - intenVect;

M = cat(2,multMat, intenVect);

temp = ones(1,size(M,2));
temp(length(temp)) = -1;
M = cat(1,M,temp);
centers = zeros(1,size(M,2) - 1);

MTemp = M;

for i = 1 : size(M,1)
      
     j = -1;
     temp = find(epsilon < M(i,:) | M(i,:) < -epsilon);
     centerFound = 0;
     t = 1;
     while ~centerFound & t <= length(temp)
          if temp(t) ~= size(M,2) & centers(temp(t)) == 0   %don't select the last column as center 
              centers(temp(t)) = i;
              centerFound = 1;
              j = temp(t);
          else
              t = t + 1;
          end
      end
       
     if j > 0
         
        %tempij = 1 / M(i,j);
        tempij = M(i,j);
        MTemp(i,:) = -M(i,:) / tempij;
        MTemp(:,j) = M(:,j) / tempij;
        MTemp(i,j) = 1 / tempij; 
            for k = 1 : size (M,1)
                for l = 1 : size(M,2)
                    if k  ~= i & l ~= j
                        MTemp(k,l) = M(k,l) - M(k,j)* M(i,l) / tempij; 
                    end
                end
            end   
        M = MTemp; 
        %MTemp(:,j) = [];
        %M(:,j) = [];    
    end
end
%format rat;
temp = find(centers);
t = 1;
while t <= length(temp)
    M(:,temp(t) - t + 1) = [];
    t = t + 1;
end
y = CreateResultMatrix(M,centers,size(multMat,2));


        